www.triceratupuz.altervista.org

This file is released with CC-by-sa license. http://creativecommons.org

<CsoundSynthesizer>
<CsOptions>
--output=TPZ05_04_-_Mikr_Tonalwsky_-_End_of_the_rat_-_Passing_and_mutating.wav --wave
-+id_artist=Mikr_Tonalwsky
-+id_copyright=CC-by-sa
-+id_software=Csound
-+id_title=Passing_and_mutating
</CsOptions>
<CsInstruments>
sr 	= 	44100	
ksmps 	= 	1
nchnls 	= 	2
0dbfs = 1
zakinit 6, 1

;p5 = 4.00 correspond to C0 16.352
giBaseFreq init 16.352
giBaseOctav init 1.68179283051

;F TABLES
;temperamet multiplication factors
giTemperment ftgen 1, 0, 32, -2, 1.0,	1.04427378243, 1.09050773267, 1.13878863476,	1.189207115, 1.24185781207, 1.29683955465, 1.35425554694, 1.41421356237, 1.47682614594, 1.54221082541, 1.61049033195

;sine wave
giSine ftgen 2, 0, 32768, 10, 1
;table of the harmonic serie
;			0	1		2		3		4		5		6		7		8		9		10		11		12		13		14		15
;			T	8va	8+5	16ma	3		5		7b		32ma	2		3		5b		5		6b		7b		7		64ma
;no overtones
giNoOvTo ftgen 3, 0, 16, -2,	3,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0
;all overtones - plate
giAllOvTo ftgen 4, 0, 16, -2,	.6, .6,.6, .6, .6, .6, .6, .6, .6, .6, .6, .6, .6, .6, .6, .6
;according consonance index - FOUNG
giConson ftgen 5, 0, 16, -2, 1, .75, .42, .75, .23, .42, .1, .75, .1, .23, .1, .42, .1, .1, .1, .75
;decreasing - cordolo
giCordo ftgen 6, 0, 16, -2, 1, .5, .333333, .25, .2, .166666, .142857, .125, .111111, .1, .090909, .083333, .076923
;little overtones - piffero
giPiffe ftgen 7, 0, 16, -2, 1, .05, .07, .05, .07, .05, .05, .05, .05, .05, .05, .05, .05, .05, .05, .05



instr 1
if p6 == 4 then
	prints "plate\n" 
elseif p6 == 5 then
	prints "fuong\n" 
elseif p6 == 6 then
	prints "cordolo\n" 
elseif p6 == 7 then
	prints "piffero\n" 
endif

ipow pow giBaseOctav, int(p5-4)
ibase = ipow * giBaseFreq
kMultipIndex = frac(p5) * 100
kMultipIndex = round(kMultipIndex)
kMultipFactor table kMultipIndex, 1

;Vibrato
ifreqvib init 0
kvib_amp linseg 0, 1, .015, 2, .006
if p9 != 0 then
	ifreqvib = p3 * .4 * p9
endif
kvib oscili kvib_amp, ifreqvib, 2

kFrequency = ibase * kMultipFactor
kFrequency = kFrequency + kFrequency * kvib

;Audio

;Volumes partials
kvolT		table 0, p6
kvol8va		table 1, p6
kvol8_5		table 2, p6
kvol16m		table 3, p6
kvol16_3	table 4, p6
kvol16_5	table 5, p6
kvol16_7	table 6, p6
kvol32m		table 7, p6
kvol32_2	table 8, p6
kvol32_3	table 9, p6
kvol32_5b	table 10, p6
kvol32_5	table 11, p6
kvol32_6b	table 12, p6
kvol32_7b	table 13, p6


;basic tone
aoutT	oscili kvolT, kFrequency, 2
;1st octave overtones
aout8va	oscili kvol8va, kFrequency * giBaseOctav, 2
kmul8_5	table 7, 1
aout8_5	oscili kvol8_5, kFrequency * giBaseOctav * kmul8_5, 2
;2nd octave overtones
aout16m	oscili kvol16m, kFrequency * giBaseOctav * giBaseOctav, 2
kmul16_3	table 4, 1
aout16_3	oscili kvol16_3, kFrequency * giBaseOctav * giBaseOctav * kmul16_3, 2
kmul16_5	table 7, 1
aout16_5	oscili kvol16_5, kFrequency * giBaseOctav * giBaseOctav * kmul16_3, 2
kmul16_7	table 10, 1
aout16_7	oscili kvol16_7, kFrequency * giBaseOctav * giBaseOctav * kmul16_7, 2
;3rd octave overtones
aout32m	oscili kvol32m, kFrequency * giBaseOctav * giBaseOctav * giBaseOctav, 2
kmul32_2	table 2, 1
aout32_2	oscili kvol32_2, kFrequency * giBaseOctav * giBaseOctav * giBaseOctav * kmul32_2, 2
kmul32_3	table 4, 1
aout32_3	oscili kvol32_3, kFrequency * giBaseOctav * giBaseOctav * giBaseOctav * kmul32_3, 2
kmul32_5b	table 5, 1
aout32_5b	oscili kvol32_5b, kFrequency * giBaseOctav * giBaseOctav * giBaseOctav * kmul32_5b, 2
kmul32_5	table 6, 1
aout32_5	oscili kvol32_5, kFrequency * giBaseOctav * giBaseOctav * giBaseOctav * kmul32_5, 2
kmul32_6b	table 7, 1
aout32_6b	oscili kvol32_6b, kFrequency * giBaseOctav * giBaseOctav * giBaseOctav * kmul32_6b, 2
kmul32_7b	table 9, 1
aout32_7b	oscili kvol32_7b, kFrequency * giBaseOctav * giBaseOctav * giBaseOctav * kmul32_7b, 2

;partials audio signals grouped by octave
aout1 = aoutT + aout8va + aout8_5
aout2 = aout16m + aout16_3 + aout16_5 + aout16_7
aout3 = aout32m + aout32_2 + aout32_3 + aout32_5b + aout32_5 + aout32_6b + aout32_7b



;Envelopes
ivol2 = .72 * p4
ivol3 = .7 * p4


if p6 == 4 then;plate
	kenvbytable expseg .001, .007, 1.1, .03, .45, 5, .001
	kenvbytable = (kenvbytable - .001) * .22
	kenvelope1 linseg 0, .001, 1, p3 - .11, 1, .05, 0
	kenvelope2 linseg 0, .001, 1, p3 - .3, ivol2 * 1.8, .04, 0
	kenvelope3 linseg 0, .001, 1, p3 - .3, ivol3 * 1.4, .05, 0
elseif p6 == 5 then;fuong
	kenvbytable  linseg 0, .05, 1.1, p3 - .1, 1.1, .05, 0
	kenvbytable = kenvbytable * .3
	kenvelope1 linseg 0, .055, 1, p3 - .11, .9, .05, 0
	kenvelope2 linseg 0, .052, 1, .05, ivol2, p3 - .3, ivol2 * 1.3, .04, 0
	kenvelope3 linseg 0, .05, 1, .05, ivol3, p3 - .3, ivol3 * 1.2, .04, 0
elseif p6 == 6 then;cordolo
	kenvbytable expseg .001, .01, 1, .07, .7, 5.0, .001
	kenvbytable = (kenvbytable - .001) * .43
	kenvelope1 linseg 0, .015, 1, p3 - .11, .9, .05, 0
	kenvelope2 linseg 0, .023, .7, .05, ivol2, p3 - .3, 1.1, .04, 0
	kenvelope3 linseg 0, .01, ivol3 * .9, p3 - .3, ivol3, .03, 0
else ;piffero
	kenvbytable  linseg 0, .05, 1.1, p3 - .1, 1.1, .05, 0
	kenvbytable = kenvbytable * .47
	kenvelope1 linseg 0, .055, 1, p3 - .11, 1, .05, 0
	kenvelope2 linseg 0, .052, 1, .05, ivol2, p3 - .3, ivol2, .04, 0
	kenvelope3 linseg 0, .05, 1, .05, ivol3, p3 - .3, ivol3, .04, 0
endif

kdeclickReleaseshort linseg 1, p3 - .06, 1, .06, 0

asig = (aout1 * kenvelope1 + aout2 * kenvelope2 + aout3 * kenvelope3) * p4 * kenvbytable * kdeclickReleaseshort


alh, arh pan2 asig, p7
;direct
zawm alh * (1 - p8), 0
zawm arh * (1 - p8), 1
;reverb
zawm alh * p8, 2
zawm arh * p8, 3
endin



instr 10;filtered reverb
alhrev zar 2
arhrev zar 3
alh init 0
arh init 0

afillh butterhp alhrev, p5
afilrh butterhp arhrev, p5

ahiglh reverb afillh, p4 + 1.491
ahigrh reverb afilrh, p4 + 1.491

;crossbubber
abufL delayr .015
		delayw alhrev + .003 * (alh + arh)
abufR delayr .015
		delayw arhrev + .003 * (alh + arh)
		

alowlh reverb alhrev * .7 + abufR * .3, p4 
alowrh reverb arhrev * .7 + abufL * .3, p4

alh butterlp alowlh * .35 + ahiglh * .85, sr/2
arh butterlp alowrh * .35 + ahigrh * .85, sr/2



zawm alh, 4
zawm arh, 5 
endin



instr 11;mixer and out
;dry
a1 zar 0
a2 zar 1
;wet
a3 zar 4
a4 zar 5

aenv linseg 1, p3 - .01, 1, .01, 0

outs (a1 + a3) * p4 * aenv, (a2 + a4) * p4 * aenv
zacl 0, 5
endin

</CsInstruments>
<CsScore>

#include "04.sco"

e

</CsScore>
</CsoundSynthesizer>
